﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CollapseManager : MonoBehaviour {

	private BoxCollider myCollider;
	private GameObject targetObject;

	private float colliderSizeX, colliderSizeY, colliderSizeZ;

	public float colliderOffsetX;

	void Start(){
		myCollider = this.gameObject.GetComponent<BoxCollider> ();

		colliderSizeX = 100;
		colliderSizeY = 100;
		colliderSizeZ = 100;
	}

	void Update(){
		if (targetObject != null) {

			colliderSizeX = Vector3.Distance (this.gameObject.transform.position, targetObject.transform.position) ;
			colliderSizeX += colliderSizeX * colliderOffsetX;

			colliderSizeY = colliderSizeX - 0.1f;

		}
		myCollider.size = new Vector3 (colliderSizeX, colliderSizeY, myCollider.size.z) ;



		if (Input.GetKeyDown (KeyCode.R)) {
			Application.LoadLevel(Application.loadedLevel);
		}
	}

	void OnTriggerEnter(Collider other){
		if (other.tag.Equals ("Probability")) {
			// Indpependent from statue
				other.gameObject.GetComponent<ProbabilityCloud> ().collapsed = true;

				targetObject = other.gameObject;

				other.gameObject.GetComponent<ProbabilityCloud> ().updateStatus ();
		} 
	}

	void OnTriggerExit(Collider other){
		if (other.tag.Equals ("Probability")) {
			// Indpependent from statue
			if (!other.gameObject.GetComponent<ProbabilityCloud> ().hasStatue) {
				other.gameObject.GetComponent<ProbabilityCloud> ().collapsed = false;

				other.gameObject.GetComponent<ProbabilityCloud> ().updateStatus ();
			}
		}
	}
}