﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ProbabilityCloud : MonoBehaviour {

	public bool hasStatue;
	public GameObject statue;

	//private Vector3 [] initPositions;

	public float offsetDiff = 1;
	public bool collapsed = false;
	public GameObject visualEffect;
	public float waveLength, amplitude, positionSnapTreshold;
	public bool allSnapped;
	public GameObject block;

	void Awake () {
		float i = 0;
		foreach (Transform child in transform) {
			if(child.gameObject.GetComponent<WaveEntity> () != null)
				child.gameObject.GetComponent<WaveEntity> ().initOffset = i;
			i+= offsetDiff;
		}
	}

	void Start(){
		allSnapped = false;
	}
	
	void Update () {
		//Enable / Disbale Visual Effects and Collider
		if (collapsed) {
			if (!visualEffect.activeSelf)
				visualEffect.SetActive (true);

			if (allSnapped)
			{
				visualEffect.SetActive (false);

				if (block.GetComponent<BoxCollider> ().enabled)
					block.GetComponent<BoxCollider> ().enabled = false;
			}
		} else {
			allSnapped = false;
			if (visualEffect.activeSelf)
				visualEffect.SetActive (false);

			if(!block.GetComponent<BoxCollider> ().enabled)
				block.GetComponent<BoxCollider> ().enabled = true;
		}
	}

	public void updateStatus(){
		// Without statue
		if (!hasStatue) {
			if (collapsed) {
				allSnapped = true;
				foreach (Transform child in transform) {
					if (child.gameObject.GetComponent<WaveEntity> () != null && !child.gameObject.GetComponent<WaveEntity> ().snapped)
						allSnapped = false;
				}

				if (allSnapped) {
					foreach (Transform child in transform) {
						if (child.gameObject.GetComponent<WaveEntity> () != null)
							child.transform.localPosition = child.gameObject.GetComponent<WaveEntity> ().initPosition;
					}
				}
			}
		} else {
			foreach (Transform child in transform) {
				if (child.gameObject.GetComponent<WaveEntity> () != null)
					child.transform.position = child.gameObject.GetComponent<WaveEntity> ().initPosition;
			}

		}
	}

	public void resetStairs(){

		Debug.Log ("Reset stairs . . .");

		allSnapped = false;
		collapsed = false;

		foreach (Transform child in transform) {
			if (child.gameObject.GetComponent<WaveEntity> () != null)
				child.gameObject.GetComponent<WaveEntity> ().time = child.gameObject.GetComponent<WaveEntity> ().initOffset;
		}

	}
}