﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Statue : MonoBehaviour {

	public bool observed;
	public GameObject probabilityCloud;

	public GameObject brokenStairs, normalStairs;

	private Material m;

	public float LookTime = 3;

	private float timer = 0;
	public Color eyeGlow = new Color (1.5f,3,3,1);

	private AudioSource sfx;
	private bool audioPlayed = false;

	public bool timerGrow = false;

	public GameObject antes;
	public GameObject depois;

	void Start ()
	{
		sfx = GetComponent<AudioSource>();

		brokenStairs.SetActive (true);
		normalStairs.SetActive (false);

		m = GetComponent<Renderer>().material;
		m.SetColor ("_EmissionColor", Color.black);
	}
	
	void Update ()
	{
		//lerp the material emmision to increase the glow until it snaps into place
		m.SetColor ("_EmissionColor", Vector4.Lerp(Color.black, eyeGlow, timer*LookTime));

		if(timerGrow)
		{
			timer += 1 * Time.deltaTime;

			if(!sfx.isPlaying)
			{
				sfx.Play();
			}
		}
		else
		{
			if(timer < 0)
			{
				timer = 0;
			}else
			{
				timer -= 1 * Time.deltaTime;

				if(sfx.isPlaying)
				{
					sfx.Stop();
				}
			}
		}

//		print(timer);
	}

	public void timeOut()
	{

		//m.SetColor ("_EmissionColor", Vector4.Lerp(eyeGlow, Color.black, timer*LookTime));

		Debug.Log("timer decreasing is "+timer);
	}

	public void switchStairs()
	{

		timerGrow = true;

		if(timer >= LookTime)
		{
			depois.GetComponent<AudioSource>().volume = 1;

			sfx.volume = 0;

			brokenStairs.SetActive (false);
			normalStairs.SetActive (true);
		}
	}
}
