﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveEntity : MonoBehaviour {

	public Vector3 initPosition;
	[HideInInspector]
	public float initOffset;
	private float waveLength;
	private float amplitude;
	private float waveValue;

	public bool posX, posY, posZ;

	public bool affecting = true;
	private const float offset = 0f;

	private float positionSnapTreshold;
	public bool snapped = false;

	public float time = 0f;


	void Start () {
		initPosition = this.gameObject.transform.localPosition;

		time = initOffset;

		waveLength = transform.parent.GetComponent<ProbabilityCloud> ().waveLength;
		amplitude = transform.parent.GetComponent<ProbabilityCloud> ().amplitude;
	}

	void Update () {

		affecting = !transform.parent.GetComponent<ProbabilityCloud> ().collapsed;

		waveLength = transform.parent.GetComponent<ProbabilityCloud> ().waveLength;
		amplitude = transform.parent.GetComponent<ProbabilityCloud> ().amplitude;
		positionSnapTreshold = transform.parent.GetComponent<ProbabilityCloud> ().positionSnapTreshold;

		//Handle transformations
		if (affecting) {
			// --- Update Time for wave behaviour ---
			time += Time.deltaTime;

			// --- Set position ---
			transform.localPosition = new Vector3 (posX ? waveValue : initPosition.x, posY ? waveValue : initPosition.y, posZ ? waveValue : initPosition.z);
		}

		if (Vector3.Distance (transform.localPosition, initPosition) <= positionSnapTreshold)
			snapped = true;
		else
			snapped = false;
		
		//Compute referece coordinates
		if(posX)
			waveValue = Mathf.Sin(time *  waveLength) * amplitude  + offset;
		else if (posY)
			waveValue = Mathf.Sin(time *  waveLength) * amplitude  + offset;
		else if (posZ)
			waveValue = Mathf.Sin(time *  waveLength) * amplitude + offset;
	}
}